#include <stdio.h>

#ifdef _MSC_VER
#pragma comment(lib,"ws2_32.lib")
#pragma warning(disable: 4996)  // _CRT_SECURE_NO_WARNINGS, Project properties->Configuration Properties->C/C++->Preprocessor->Preprocessor Definitions
#include <winsock2.h>
#endif

#ifdef __GNUC__
#include <windows.h>
#endif

#define UDP_PORT (6000)
char szIPDest[20];

DWORD WINAPI threadRicezione(LPVOID lpParameter);
int Trasmissione(void);

unsigned int ip2int(const char * ip);

int main(int n, char** s)
{
    DWORD dwthread;
    WORD wVersionRequested;
    WSADATA wsaData;
    unsigned int ui;

    s++;  //  il secondo parametro su linea di comando
    strcpy(szIPDest,*s);
    printf("\tIP destinazione: %s ",szIPDest);

    ui = ip2int(szIPDest);
    if (ui==0)
    {
        printf("\nIP destinazione: %s  non valido",szIPDest);
        return 1;
    }


    printf("\t------UDP p2p------\n");
    wVersionRequested = MAKEWORD(2,2);
    if (WSAStartup( wVersionRequested, &wsaData)) return 1;
    if (LOBYTE(wsaData.wVersion) != 2 || HIBYTE(wsaData.wVersion) != 2 )
    {
        WSACleanup();
        return 2;
    }

    CreateThread(NULL, 0, threadRicezione,(LPVOID)0, 1024, &dwthread);
    Trasmissione();
    return 0;
}

int Trasmissione(void)
{
    SOCKET sockTx;
    SOCKADDR_IN addrRemoto;
    char sendBuf[100], szTmp[20]= {0};

    sockTx = socket(AF_INET,SOCK_DGRAM,0);
    addrRemoto.sin_family = AF_INET;
    addrRemoto.sin_port = htons(UDP_PORT);
    addrRemoto.sin_addr.S_un.S_addr = inet_addr(szIPDest);

    while(szTmp[0]!='x')
    {
        Sleep(500);
        printf("\tIP destinazione (0=%s, x=Exit): ",szIPDest);
        scanf("%s",szTmp);
        if (szTmp[0]!='0')
        {
            strcpy(szIPDest,szTmp);
            addrRemoto.sin_addr.S_un.S_addr=inet_addr(szIPDest);
        }
        if (szTmp[0]!='x')
        {
            printf("\n\tMessaggio: ");
            scanf("%s",sendBuf);
            sendto(sockTx, sendBuf, strlen(sendBuf)+1, 0, (SOCKADDR*)&addrRemoto, sizeof(SOCKADDR));
        }
    }
    closesocket(sockTx);
    WSACleanup();
    return 0;
}

DWORD WINAPI threadRicezione(LPVOID lpParameter)
{
    SOCKET sockRx;
    SOCKADDR_IN addrLocale, addrRemoto;
    char recBuff[100];
    int lsockaddr, nbytes;

    lsockaddr = sizeof(SOCKADDR);
    sockRx = socket(AF_INET,SOCK_DGRAM,0);
    addrLocale.sin_family = AF_INET;
    addrLocale.sin_addr.S_un.S_addr = htonl(INADDR_ANY);
    addrLocale.sin_port = htons(UDP_PORT);
    bind(sockRx,(SOCKADDR*)&addrLocale, sizeof(SOCKADDR));

    printf("\n\tIn ricezione su porta %d...\n",UDP_PORT);
    while(1)
    {
        nbytes = recvfrom(sockRx, recBuff, sizeof(recBuff), 0,(SOCKADDR*)&addrRemoto, &lsockaddr);
        recBuff[nbytes] = 0;
        printf("\n\tRicevuto da:\t%s il messaggio: %s\n",inet_ntoa(addrRemoto.sin_addr),recBuff);
        printf("\n\tIP destinazione (0=%s, x=Exit): ",szIPDest);
    }
    closesocket(sockRx);
    WSACleanup();
}


unsigned int ip2int(const char * ip)
{
    unsigned v = 0;
    int i;
    const char *start;

    start = ip;
    for (i = 0; i < 4; i++)
    {
        char c;
        int n = 0;
        while (1)
        {
            c = * start;
            start++;
            if (c >= '0' && c <= '9')
            {
                n *= 10;
                n += c - '0';
            }
            else
            {
              if ((i < 3 && c == '.') || c==0) break;
              else return 0;
            }
        }
        if (n >= 256) return 0;
        v *= 256;
        v += n;
    }

    return v;
}




